<?php
/**
 * @package     JohnCMSVN
 * @link        http://johncmsvn.com
 * @copyright   Copyright (C) 2014 JohnCMSVN Community
 * @license     LICENSE.txt (see attached file)
 * @version     VERSION.txt (see attached file)
 * @author      Văn Việt
 */

defined('_IN_JOHNADM') or die('Error: restricted access');

// Проверяем права доступа
if ($rights < 7) {
    header('Location: http://johncmsvn.com');
    exit;
}
echo '<div class="main-xmenu">';
echo '<div class="danhmuc"><a href="index.php"><b>' . $lng['admin_panel'] . '</b></a> › ' . $lng['news_on_frontpage'] . '</div>';

/*
-----------------------------------------------------------------
Настройки Новостей
-----------------------------------------------------------------
*/
if (!isset($set['news']) || isset($_GET['reset'])) {
    // Задаем настройки по умолчанию
    $settings = array (
        'view' => '1',
        'size' => '200',
        'quantity' => '3',
        'days' => '7',
        'breaks' => '1',
        'smileys' => '0',
        'tags' => '1',
        'kom' => '1'
    );
    @mysql_query("DELETE FROM `cms_settings` WHERE `key` = 'news'");
    mysql_query("INSERT INTO `cms_settings` SET
        `key` = 'news',
        `val` = '" . mysql_real_escape_string(serialize($settings)) . "'
    ");
    echo '<div class="menu list-top">' . $lng['settings_default'] . '</div>';
} elseif (isset($_POST['submit'])) {
    // Принимаем настройки из формы
    $settings['view'] = isset($_POST['view']) && $_POST['view'] >= 0 && $_POST['view'] < 4 ? intval($_POST['view']) : 1;
    $settings['size'] = isset($_POST['size']) && $_POST['size'] > 50 && $_POST['size'] < 500 ? intval($_POST['size']) : 200;
    $settings['quantity'] = isset($_POST['quantity']) && $_POST['quantity'] > 0 && $_POST['quantity'] < 16 ? intval($_POST['quantity']) : 3;
    $settings['days'] = isset($_POST['days']) && $_POST['days'] > 0 && $_POST['days'] < 16 ? intval($_POST['days']) : 7;
    $settings['breaks'] = isset($_POST['breaks']);
    $settings['smileys'] = isset($_POST['smileys']);
    $settings['tags'] = isset($_POST['tags']);
    $settings['kom'] = isset($_POST['kom']);
    mysql_query("UPDATE `cms_settings` SET
        `val` = '" . mysql_real_escape_string(serialize($settings)) . "'
        WHERE `key` = 'news'
    ");
    echo '<div class="menu list-top">' . $lng['settings_saved'] . '</div>';
} else {
    // Получаем сохраненные настройки
    $settings = unserialize($set['news']);
}

/*
-----------------------------------------------------------------
Форма ввода настроек
-----------------------------------------------------------------
*/
echo '<form action="index.php?act=news" method="post">' .
    '<div class="menu list-top"><h3>' . $lng['apperance'] . '</h3></div>' .
    '<div class="menu list-top"><input type="radio" value="1" name="view" ' . ($settings['view'] == 1 ? 'checked="checked"' : '') . '/>&#160;' . $lng['heading_and_text'] . '</div>' .
    '<div class="menu list-top"><input type="radio" value="2" name="view" ' . ($settings['view'] == 2 ? 'checked="checked"' : '') . '/>&#160;' . $lng['heading'] . '</div>' .
    '<div class="menu list-top"><input type="radio" value="3" name="view" ' . ($settings['view'] == 3 ? 'checked="checked"' : '') . '/>&#160;' . $lng['text'] . '</div>' .
    '<div class="menu list-top"><input type="radio" value="0" name="view" ' . (!$settings['view'] ? 'checked="checked"' : '') . '/>&#160;<b>' . $lng['dont_display'] . '</b></div>' .
    '<div class="menu list-top"><input name="breaks" type="checkbox" value="1" ' . ($settings['breaks'] ? 'checked="checked"' : '') . ' />&#160;' . $lng['line_foldings'] . '</div>' .
    '<div class="menu list-top"><input name="smileys" type="checkbox" value="1" ' . ($settings['smileys'] ? 'checked="checked"' : '') . ' />&#160;' . $lng['smileys'] . '</div>' .
    '<div class="menu list-top"><input name="tags" type="checkbox" value="1" ' . ($settings['tags'] ? 'checked="checked"' : '') . ' />&#160;' . $lng['bbcode'] . '</div>' .
    '<div class="menu list-top"><input name="kom" type="checkbox" value="1" ' . ($settings['kom'] ? 'checked="checked"' : '') . ' />&#160;' . $lng['comments'] . '</div>' .
    '<div class="menu list-top"><h3>' . $lng['text_size'] . '</h3>&#160;</div>' .
    '<div class="menu list-top"><input type="text" size="3" maxlength="3" name="size" value="' . $settings['size'] . '" />&#160;(50 - 500)</div>' .
    '<div class="menu list-top"><h3>' . $lng['news_count'] . '</h3>&#160;</div>' .
    '<div class="menu list-top"><input type="text" size="3" maxlength="2" name="quantity" value="' . $settings['quantity'] . '" />&#160;(1 - 15)</div>' .
    '<div class="menu list-top"><h3>' . $lng['news_howmanydays_display'] . '</h3></div>
	<div class="menu list-top"><input type="text" size="3" maxlength="2" name="days" value="' . $settings['days'] . '" />&#160;(0 - 15)</div>' .
    '<div class="menu list-top"><small>0 - ' . $lng['without_limit'] . '</small></p></div>' .
    '<div class="menu list-top"><input type="submit" value="' . $lng['save'] . '" name="submit" /></div>' .
    '<div class="menu list-top"><a href="index.php?act=news&amp;reset">' . $lng['reset_settings'] . '</a></div>' .
    '</form>' .
    '<div class="menu list-top"><a href="index.php">' . $lng['admin_panel'] . '</a></div>' .
    '<div class="menu list-top"><a href="../news/index.php">' . $lng['to_news'] . '</a></div>';
	echo '</div>';
?>